#-----------------------------------------------
# cut.awk               Created by: Cliff Cote
#                       Date:       10/30/95
#
# Revisions:
#
#----------------------------------------------- 
BEGIN {FS="";gmode = "none";num = "none";tlcount=1;
       plnmode = "G17";lastmode = "none";first = "yes";
       xmode = "no";ymode = "no";zmode = "no";
       theoldx=0;theoldy=0;theoldz=0}{

#---------- search strings ---------------------

       searchT = match($0,"T")
       searchX = match($0,"X")
       searchY = match($0,"Y")
       searchZ = match($0,"Z")
       searchI = match($0,"I")
       searchJ = match($0,"J")
       searchK = match($0,"K")
       searchG01 = match($0,"G01")
       searchG1 = match($0,"G1")
       searchG00 = match($0,"G00")
       searchG0 = match($0,"G0")
       searchG02 = match($0,"G02")
       searchG2 = match($0,"G2")
       searchG03 = match($0,"G03")
       searchG3 = match($0,"G3")
       searchG17 = match($0,"G17")
       searchG18 = match($0,"G18")
       searchG19 = match($0,"G19")
       endline = length($0)

#--------- Tool change ----------------------------
        
       if ( searchT != 0 ) {
          tlnum = substr($0,searchT+1,endline)
          lnum = int(tlnum)
          if ( lnum > 0 ) {
            if ( lastmode == "G01" ) {
               calxyz(searchX,searchY,searchZ,endline)
               printf ("        %.6f, %.6f, %.6f,\n", thex,they,thez) 
               print "        }"
               print "        ]" 
            }
            print "ON_LAYER[LY="tlcount"]"
            tlcount = tlcount + 1
            if ( lastmode == "G01" ) {
               calxyz(searchX,searchY,searchZ,endline)
               print "START_PROF[LV=0]"
               print "POLYLINE[CE=0,"
               printf ("    CL={%.6f, %.6f, %.6f,\n", thex,they,thez)
               gmode = "G01"
               lastmode = "G01"
            }
          }
       }  

#--------- Determine Linear gmode -----------------

       if ( searchG00 != 0 && mode == "rapid" ) {
          gmode = "G00"
       }
       if ( searchG00 != 0 && mode == "no_rapid" ) {
          gmode = "none"
          calxyz(searchX,searchY,searchZ,endline)
          if ( lastmode == "G01" ) {
             print "        }"
             print "        ]"
          }
          lastmode = "none"
       }
       if ( searchG01 != 0 ) {
          gmode = "G01"
       }
       if ( searchG0 != 0 && mode == "rapid" ) {
          theG0 = substr($0,searchG0+1,endline)
          num = int(theG0) 
          if ( num == "0" ) {
               gmode = "G00"
          } 
       }
       if ( searchG0 != 0 && mode == "no_rapid" ) {
          theG0 = substr($0,searchG0+1,endline)
          num = int(theG0) 
          if ( num == "0" ) {
               gmode = "none"
               calxyz(searchX,searchY,searchZ,endline)
               if ( lastmode == "G01" ) {
                  print "        }"
                  print "        ]"
               }
               lastmode = "none"
          } 
       }
       if ( searchG1 != 0 ) {
          theG1 = substr($0,searchG1+1,endline)
          num = int(theG1)
          if ( num != "1" ) {
             searchG1 = match(theG1,"G1")
             the2G1 = substr(theG1,searchG1+1,endline)
             num = int(the2G1)
          }
          if ( num == "1" ) {
               gmode = "G01"
          } 
       }

#------------ Determine Arc gmode and plnmode --------------

       if ( searchG17 != 0 ) {
          plnmode = "G17"
       }
       if ( searchG18 != 0 ) {
          plnmode = "G18"
       }
       if ( searchG19 != 0 ) {
          plnmode = "G19"
       }
       if ( searchG02 != 0 ) {
          gmode = "G02"
       }
       if ( searchG03 != 0 ) {
          gmode = "G03"
       }
       if ( searchG2 != 0 ) {
          theG2 = substr($0,searchG2+1,endline)
          num = int(theG2) 
          if ( num == "2" ) {
               gmode = "G02"
          } 
       }
       if ( searchG3 != 0 ) {
          theG3 = substr($0,searchG3+1,endline)
          num = int(theG3)
          if ( num == "3" ) {
               gmode = "G03"
          } 
       }

       if ( gmode == "G02" || gmode == "G03" ) { 
         if ( searchI != 0 && searchJ != 0 ) {
            plnmode = "G17"
         }
         if ( searchI != 0 && searchK != 0 ) {
            plnmode = "G18"
         }
         if ( searchJ != 0 && searchK != 0 ) {
            plnmode = "G19"
         }
       }
     

#---------- Misc Conditions  -------------------------------

       if ( searchX != 0 || searchY != 0 || searchZ != 0 ) {
          if ( gmode != "G03" && gmode != "G02" && gmode != "G00" && gmode != "G01" ) {
             calxyz(searchX,searchY,searchZ,endline)
          }
       }  
       if ( searchX == 0 && searchY == 0 && searchZ == 0 ) {
          if ( searchG00 == 0 && searchG01 == 0 && searchG02 == 0 && searchG03 == 0 ) {
             if ( searchG0 == 0 && searchG1 == 0 && searchG2 == 0 && searchG3 == 0 ) {
                next
             }
          }
       }
       if ( searchX != 0 || searchY != 0 || searchZ != 0 ) {
          if ( gmode == "none" && lastmode == "G01" ) {
                   gmode = "G01"
          }
       }
       if ( searchX != 0 ) {
          xmode = "yes"
       }
       if ( searchY != 0 ) {
          ymode = "yes"
       }
       if ( searchZ != 0 ) {
          zmode = "yes"
       }
       if ( xmode == "no" || ymode == "no" || zmode == "no" ) {
          calxyz(searchX,searchY,searchZ,endline)
          next
       }
       if ( xmode == "yes" && ymode == "yes" && zmode == "yes" && first == "yes" ) {
          if ( linmode != "incremental" ) { 
             thex = 0
             they = 0
             thez = 0
             theoldx = 0
             theoldy = 0
             theoldz = 0
          }
          calxyz(searchX,searchY,searchZ,endline)
          first = "no"
          next
       }

#------------ Rapid and Linear section ---------------------

       if ( gmode == "G01" || gmode == "G00" ) {
          gmode = "G01"
          if ( gmode != lastmode ) {
             print "START_PROF[LV=0]"
             print "POLYLINE[CE=0,"
             if ( lastmode == "G02" || lastmode == "G03" || lastmode == "none" ) {
                  printf ("    CL={%.6f, %.6f, %.6f,\n", thex,they,thez)
                  calxyz(searchX,searchY,searchZ,endline)
                  printf ("        %.6f, %.6f, %.6f,\n", thex,they,thez)
             }
             if ( lastmode != "G02" && lastmode != "G03" && lastmode != "none" ) {
                calxyz(searchX,searchY,searchZ,endline)
                printf ("    CL={%.6f, %.6f, %.6f,\n", thex,they,thez)
             }
          lastmode = "G01"
          next
          }
          calxyz(searchX,searchY,searchZ,endline)
          printf ("        %.6f, %.6f, %.6f,\n", thex,they,thez) 
       }

#----------- Arc XY Section --------------------------------

   if ( plnmode == "G17" ) {
       if ( gmode == "G02" || gmode == "G03" ) {
          if ( lastmode == "G01" ) {
             print "        }"
             print "        ]" 
          }
          stpointx = thex
          stpointy = they
          stpointz = thez
          calcenter(stpointx,stpointy,stpointz,thei,thej,thek)
          calrad(stpointx,stpointy,stpointz,centerx,centery,centerz)
          calxyz(searchX,searchY,searchZ,endline)
          endpointx = thex
          endpointy = they
          endpointz = thez
          if ( arcdirxy != "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointy, endpointx, endpointy, thez)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointy, endpointx, endpointy, thez)
               lastmode = "G03"
            }
          }
          if ( arcdirxy == "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointy, endpointx, endpointy, thez)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointy, endpointx, endpointy, thez)
               lastmode = "G03"
            }
          }
       }
   }

#------------- Arc XZ Section -----------------------------------

   if ( plnmode == "G18" ) {
       if ( gmode == "G02" || gmode == "G03" ) {
          if ( lastmode == "G01" ) {
             print "        }"
             print "        ]" 
          }
          stpointx = thex
          stpointy = they
          stpointz = thez
          calcenter(stpointx,stpointy,stpointz,thei,thej,thek)
          calrad(stpointx,stpointy,stpointz,centerx,centery,centerz)
          calxyz(searchX,searchY,searchZ,endline)
          endpointx = thex
          endpointy = they
          endpointz = thez
          reverse = -1*they
          if ( arcdirxz != "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ON_LAYER[WP=%cXZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointz, endpointx, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ON_LAYER[WP=%cXZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointz, endpointx, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse) 
               lastmode = "G03"
            }
          }
          if ( arcdirxz == "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ON_LAYER[WP=%cXZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointz, endpointx, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ON_LAYER[WP=%cXZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointx, stpointz, endpointx, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse) 
               lastmode = "G03"
            }
          }
       }
   }

#------------- Arc YZ Section ---------------------------------------

   if ( plnmode == "G19" ) {
       if ( gmode == "G02" || gmode == "G03" ) {
          if ( lastmode == "G01" ) {
             print "        }"
             print "        ]" 
          }
          stpointx = thex
          stpointy = they
          stpointz = thez
          calcenter(stpointx,stpointy,stpointz,thei,thej,thek)
          calrad(stpointx,stpointy,stpointz,centerx,centery,centerz)
          calxyz(searchX,searchY,searchZ,endline)
          endpointx = thex
          endpointy = they
          endpointz = thez
          reverse = 1*thex
          if ( arcdiryz != "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ON_LAYER[WP=%cYZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointy, stpointz, endpointy, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ON_LAYER[WP=%cYZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointy, stpointz, endpointy, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse) 
               lastmode = "G03"
            }
          } 
          if ( arcdiryz == "reverse" ) {
            if ( gmode == "G02" ) {
               printf ("ON_LAYER[WP=%cYZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=1, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointy, stpointz, endpointy, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               lastmode = "G02"
            }
            if ( gmode == "G03" ) {
               printf ("ON_LAYER[WP=%cYZ_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse)
               printf ("ARC[DR=0, RA=%.6f, XS=%.6f, YS=%.6f, XE=%.6f, YE=%.6f, LV=%.6f]\n", radius, stpointy, stpointz, endpointy, endpointz, reverse)
               printf ("ON_LAYER[WP=%cXY_PLANE%c, LV=%.6f, PT=0]\n", 034, 034, reverse) 
               lastmode = "G03"
            }
          } 
       }
   }

#------------- Function to determine x,y,z ----------------------

}
function calxyz(searchX,searchY,searchZ,endline)
{
             if ( implied == 0 ) {
                places = 1.0
             }
             if ( implied == 1 ) {
                places = 10.0
             }
             if ( implied == 2 ) {
                places = 100.0
             }
             if ( implied == 3 ) {
                places = 1000.0
             }
             if ( implied == 4 ) {
                places = 10000.0
             }
             if ( implied == 5 ) {
                places = 100000.0
             }
             if ( implied == 6 ) {
                places = 1000000.0
             }
             if ( searchX != 0 && searchY != 0 && searchZ != 0 ) {
                if ( NR != oldnr ) {
                   thex = (substr($0,searchX+1,endline))/places
                   they = (substr($0,searchY+1,endline))/places
                   thez = (substr($0,searchZ+1,endline))/places
                   if ( linmode == "incremental" ) {
                      thex = thex + theoldx 
                      they = they + theoldy
                      thez = thez + theoldz
                   }
                   theoldx = thex
                   theoldy = they
                   theoldz = thez
                }
             }
             if ( searchX != 0 && searchY != 0 && searchZ == 0 ) {
                if ( NR != oldnr ) {
                   thex = (substr($0,searchX+1,endline))/places
                   they = (substr($0,searchY+1,endline))/places
                   if ( linmode == "incremental" ) {
                      thex = thex + theoldx
                      they = they + theoldy
                   }
                   theoldx = thex
                   theoldy = they
                }
             }
             if ( searchX != 0 && searchY == 0 && searchZ != 0 ) {
                if ( NR != oldnr ) {
                   thex = (substr($0,searchX+1,endline))/places
                   thez = (substr($0,searchZ+1,endline))/places 
                   if ( linmode == "incremental" ) {
                      thex = thex + theoldx
                      thez = thez + theoldz
                   }
                   theoldx = thex
                   theoldz = thez
                }
             }
             if ( searchX == 0 && searchY != 0 && searchZ != 0 ) {
                if ( NR != oldnr ) {
                   they = (substr($0,searchY+1,endline))/places
                   thez = (substr($0,searchZ+1,endline))/places 
                   if ( linmode == "incremental" ) {
                      they = they + theoldy
                      thez = thez + theoldz
                   }
                   theoldy = they
                   theoldz = thez 
                }
             }
             if ( searchX != 0 && searchY == 0 && searchZ == 0 ) {
                if ( NR != oldnr ) {
                   thex = (substr($0,searchX+1,endline))/places 
                   if ( linmode == "incremental" ) {
                      thex = thex + theoldx
                   }
                   theoldx = thex
                }
             }
             if ( searchX == 0 && searchY != 0 && searchZ == 0 ) {
                if ( NR != oldnr ) {
                   they = (substr($0,searchY+1,endline))/places
                   if ( linmode == "incremental" ) {
                      they = they + theoldy
                   }
                   theoldy = they
                }
             }
             if ( searchX == 0 && searchY == 0 && searchZ != 0 ) {
                if ( NR != oldnr ) {
                   thez = (substr($0,searchZ+1,endline))/places
                   if ( linmode == "incremental" ) {
                      thez = thez + theoldz
                   }
                   theoldz = thez
                }
             }
             oldnr = NR

return thex they thez
}

function calcenter(stpointx,stpointy,stpointz,thei,thej,thek){

             if ( implied == 0 ) {
                places = 1.0
             }
             if ( implied == 1 ) {
                places = 10.0
             }
             if ( implied == 2 ) {
                places = 100.0
             }
             if ( implied == 3 ) {
                places = 1000.0
             }
             if ( implied == 4 ) {
                places = 10000.0
             }
             if ( implied == 5 ) {
                places = 100000.0
             }
             if ( implied == 6 ) {
                places = 1000000.0
             }

             searchI = match($0,"I")
             searchJ = match($0,"J")
             searchK = match($0,"K")
             searchR = match($0,"R")
             thei = (substr($0,searchI+1,endline))/places
             thej = (substr($0,searchJ+1,endline))/places
             thek = (substr($0,searchK+1,endline))/places
             if ( arcmode == "start_center" ) {
                centerx = stpointx + thei
                centery = stpointy + thej
                centerz = stpointz + thek
             }
             if ( arcmode == "center_start" ) {
                centerx = stpointx - thei
                centery = stpointy - thej
                centerz = stpointz - thek
             }
             if ( arcmode == "absolute" ) {
                centerx = thei
                centery = thej
                centerz = thek
             }

return centerx centery centerz thei thej thek

}
#----------- Function to determine radius of arc -----------------

function calrad(thex,they,thez,centerx,centery,centerz){

                vecx = centerx - stpointx
                vecy = centery - stpointy
                vecz = centerz - stpointz 
                if ( plnmode == "G17" ) {
                   radius = ((vecx)^2 + (vecy)^2)^.5
                }
                if ( plnmode == "G18" ) {
                   radius = ((vecx)^2 + (vecz)^2)^.5   
                }
                if ( plnmode == "G19" ) {
                   radius = ((vecy)^2 + (vecz)^2)^.5   
                }
                if ( searchR != 0 ) {
                   radius = (substr($0,searchR+1,endline))/places
                }

return stpointx stpointy stpointz radius
}
 
END { if ( lastmode == "G01" || lastmode == "G00" ) {
         print "        }"
         print "        ]"
      }
    }
